#include <stdio.h>
#include <stdlib.h>
#include <ogcsys.h>
#include <string.h> //for parsing parameters
#include <unistd.h> //for sleep

#include "disc.h"
#include "subsystem.h"
#include "sys.h"
#include "video.h"
#include "menu.h"


int main(int argc, char **argv){
	int ret, ios=249;

	// Parse parameters
	if(argc>1){
		int i;
		for(i=1; i<argc; i++){
			if(strncmp("--ios=", argv[i], 6)==0)
				ios=atoi(strchr(argv[i], '=')+1);
		}
	}

	// Load Custom IOS
	ret=IOS_ReloadIOS(ios);

	// Initialize system
	Sys_Init();

	// Initialize subsystems
	Subsystem_Init();

	// Set video mode
	Video_SetMode();

	// Initialize console
	#ifdef DEBUG_MODE
	Con_Init(CONSOLE_X, CONSOLE_Y, CONSOLE_WIDTH, CONSOLE_HEIGHT);
	printf("Mighty Loader TEST\n");	
	#endif

	// Check if Custom IOS is loaded
	if(ret<0){
		Con_Init(CONSOLE_X, CONSOLE_Y, CONSOLE_WIDTH, CONSOLE_HEIGHT);
		printf("* ERROR: I can't load IOS%d (ret = %d)", ios, ret);
		sleep(2);
		goto out;
	}

	// Initialize DIP module
	ret = Disc_Init();
	if(ret < 0){
		Con_Init(CONSOLE_X, CONSOLE_Y, CONSOLE_WIDTH, CONSOLE_HEIGHT);
		printf("* ERROR: I can't start DIP module (ret = %d)", ret);
		sleep(2);
		goto out;
	}

	// Menu loop
	Menu_Loop();

out:
	exit(0);
}
